=== debian/changelog ===
visp (2.10.0-4build3) wily; urgency=medium

  * No-change rebuild against libogre-1.9.0v5.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 15 Aug 2015 09:10:19 +0200

visp (2.10.0-4build2) wily; urgency=medium

  * No-change rebuild against libcoin80v5.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 10 Aug 2015 07:45:10 +0200

visp (2.10.0-4build1) wily; urgency=medium

  * No-change rebuild using GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 05 Aug 2015 14:54:29 +0200

visp (2.10.0-4) unstable; urgency=medium

  * Add patch to make build reproductible (Closes: #790074).

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Wed, 15 Jul 2015 10:31:53 +0200

visp (2.10.0-3) unstable; urgency=medium

  * Override dh_install to avoid an error on kfreebsd where usr/lib/*/visp/*
    doesn't exist

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Mon, 18 May 2015 08:49:35 +0200

visp (2.10.0-2) unstable; urgency=medium

  * Add patch to fix segfault on sparc, powerpc...
  * Override dh_install to avoid an error on hurd where usr/lib/*/visp/*
    doesn't exist

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Tue, 12 May 2015 14:38:23 +0200

visp (2.10.0-1) unstable; urgency=medium

  * Imported Upstream version 2.10.0
  * Remove obsolete patches, bump ABI to 2.10
  * Fix lintian dep5-copyright-license-name-not-unique and 
    space-in-std-short-name-in-dep5-copyright warnings
  * Override lintian embedded-javascript-library warning
  * Add patch to install headers in architecture triplet
  * Add patch to be able to use the library either from build dir of from 
    install dir. Now VISP_SCENES_DIR, VISP_ROBOT_ARMS_DIR, 
    VISP_HAVE_OGRE_PLUGINS_PATH, VISP_HAVE_OGRE_RESOURCES_PATH defined in 
    vpConfig.h may contain multiple path locations separated with ; character.
    These locations are the one to found the resources in the build tree, and
    the one to found the resources in the install tree.

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Sun, 15 Mar 2015 10:38:16 +0100
